4 read -rd "\000" helpmessage <<EOF
5 $(basename $0): Build Arvados packages and (optionally) upload them.
8 WORKSPACE=/path/to/arvados $(basename $0) [options]
13 Upload packages (default: false)
15 scp user for repository server (only required when --upload is specified)
17 scp host for repository server (only required when --upload is specified)
18 --build-bundle-packages (default: false)
19 Build api server and workbench packages with vendor/bundle included
21 Output debug information (default: false)
23 Distribution to build packages for (default: debian7)
25 WORKSPACE=path Path to the Arvados source tree to build packages from
34 BUILD_BUNDLE_PACKAGES=0
37 PARSEDOPTS=$(getopt --name "$0" --longoptions \
38 help,upload,scp-user:,scp-host:,build-bundle-packages,debug,target: \
44 eval set -- "$PARSEDOPTS"
45 while [ $# -gt 0 ]; do
48 echo >&2 "$helpmessage"
67 --build-bundle-packages)
68 BUILD_BUNDLE_PACKAGES=1
72 echo >&2 "$0: unrecognized argument '$2'. Try: $0 --help"
81 if [[ "$UPLOAD" != '0' && ("$SCPUSER" == '' || "$SCPHOST" == '') ]]; then
82 echo >&2 "$helpmessage"
84 echo >&2 "Error: please specify --scp-user and --scp-host if --upload is set"
89 declare -a PYTHON_BACKPORTS PYTHON3_BACKPORTS
92 PYTHON3_VERSION=$(python3 -c 'import sys; print("{v.major}.{v.minor}".format(v=sys.version_info))')
98 REPO_UPDATE_CMD='freight add *deb apt/wheezy && freight cache && rsync -AaHX /var/www/freight/ /var/www/freight-production/ --delete && rm -f *deb'
100 PYTHON2_PACKAGE=python$PYTHON2_VERSION
101 PYTHON2_PKG_PREFIX=python
102 PYTHON3_PACKAGE=python$PYTHON3_VERSION
103 PYTHON3_PKG_PREFIX=python3
104 PYTHON_BACKPORTS=(python-gflags pyvcf google-api-python-client \
105 oauth2client pyasn1==0.1.7 pyasn1-modules==0.0.5 \
106 rsa uritemplate httplib2 ws4py \
107 virtualenv pykka apache-libcloud requests six pyexecjs jsonschema \
108 ciso8601 pycrypto backports.ssl_match_hostname pycurl llfuse)
109 PYTHON3_BACKPORTS=(docker-py six requests)
114 REPO_UPDATE_CMD='freight add *deb apt/precise && freight cache && rsync -AaHX /var/www/freight/ /var/www/freight-production/ --delete && rm -f *deb'
116 PYTHON2_PACKAGE=python$PYTHON2_VERSION
117 PYTHON2_PKG_PREFIX=python
118 PYTHON3_PACKAGE=python$PYTHON3_VERSION
119 PYTHON3_PKG_PREFIX=python3
120 PYTHON_BACKPORTS=(python-gflags pyvcf google-api-python-client \
121 oauth2client pyasn1==0.1.7 pyasn1-modules==0.0.5 \
122 rsa uritemplate httplib2 ws4py \
123 virtualenv pykka apache-libcloud requests six pyexecjs jsonschema \
124 ciso8601 pycrypto backports.ssl_match_hostname pycurl llfuse)
125 PYTHON3_BACKPORTS=(docker-py six requests)
130 REPO_UPDATE_CMD='mv *rpm /var/www/rpm.arvados.org/CentOS/6/os/x86_64/ && createrepo /var/www/rpm.arvados.org/CentOS/6/os/x86_64/'
132 PYTHON2_PACKAGE=$(rpm -qf "$(which python$PYTHON2_VERSION)" --queryformat '%{NAME}\n')
133 PYTHON2_PKG_PREFIX=$PYTHON2_PACKAGE
134 PYTHON3_PACKAGE=$(rpm -qf "$(which python$PYTHON3_VERSION)" --queryformat '%{NAME}\n')
135 PYTHON3_PKG_PREFIX=$PYTHON3_PACKAGE
136 PYTHON_BACKPORTS=(python-gflags pyvcf google-api-python-client \
137 oauth2client pyasn1==0.1.7 pyasn1-modules==0.0.5 \
138 rsa uritemplate httplib2 ws4py \
139 pykka apache-libcloud requests six pyexecjs jsonschema \
140 ciso8601 pycrypto backports.ssl_match_hostname pycurl
141 python-daemon lockfile llfuse)
142 PYTHON3_BACKPORTS=(docker-py six requests)
143 export PYCURL_SSL_LIBRARY=nss
146 echo -e "$0: Unknown target '$TARGET'.\n" >&2
152 if ! [[ -n "$WORKSPACE" ]]; then
153 echo >&2 "$helpmessage"
155 echo >&2 "Error: WORKSPACE environment variable not set"
161 fpm --version >/dev/null 2>&1
163 if [[ "$?" != 0 ]]; then
164 echo >&2 "$helpmessage"
166 echo >&2 "Error: fpm not found"
171 find_easy_install() {
172 for version_suffix in "$@"; do
173 if "easy_install$version_suffix" --version >/dev/null 2>&1; then
174 echo "easy_install$version_suffix"
181 Error: easy_install$1 (from Python setuptools module) not found
187 EASY_INSTALL2=$(find_easy_install -$PYTHON2_VERSION "")
188 EASY_INSTALL3=$(find_easy_install -$PYTHON3_VERSION 3)
190 RUN_BUILD_PACKAGES_PATH="`dirname \"$0\"`"
191 RUN_BUILD_PACKAGES_PATH="`( cd \"$RUN_BUILD_PACKAGES_PATH\" && pwd )`" # absolutized and normalized
192 if [ -z "$RUN_BUILD_PACKAGES_PATH" ] ; then
193 # error; for some reason, the path is not accessible
194 # to the script (e.g. permissions re-evaled after suid)
198 if [[ "$DEBUG" != 0 ]]; then
199 echo "$0 is running from $RUN_BUILD_PACKAGES_PATH"
200 echo "Workspace is $WORKSPACE"
204 # Generates a version number from the git log for the current working
205 # directory, and writes it to stdout.
206 local git_ts git_hash
207 declare $(TZ=UTC git log -n1 --first-parent \
208 --format=format:"git_ts=%ct git_hash=%h" .)
209 echo "0.1.$(date -ud "@$git_ts" +%Y%m%d%H%M%S).$git_hash"
212 timestamp_from_git() {
213 # Generates a version number from the git log for the current working
214 # directory, and writes it to stdout.
215 local git_ts git_hash
216 declare $(TZ=UTC git log -n1 --first-parent \
217 --format=format:"git_ts=%ct git_hash=%h" .)
221 handle_python_package () {
222 # This function assumes the current working directory is the python package directory
223 if [[ "$UPLOAD" != 0 ]]; then
224 # Make sure only to use sdist - that's the only format pip can deal with (sigh)
225 if [[ "$DEBUG" != 0 ]]; then
226 python setup.py sdist upload
228 python setup.py -q sdist upload
231 # Make sure only to use sdist - that's the only format pip can deal with (sigh)
232 if [[ "$DEBUG" != 0 ]]; then
233 python setup.py sdist
235 python setup.py -q sdist
240 # Build packages for everything
241 fpm_build_and_scp () {
242 # The package source. Depending on the source type, this can be a
243 # path, or the name of the package in an upstream repository (e.g.,
247 # The name of the package to build. Defaults to $PACKAGE.
248 PACKAGE_NAME=${1:-$PACKAGE}
250 # Optional: the vendor of the package. Should be "Curoverse, Inc." for
251 # packages of our own software. Passed to fpm --vendor.
254 # The type of source package. Passed to fpm -s. Default "python".
255 PACKAGE_TYPE=${1:-python}
257 # Optional: the package version number. Passed to fpm -v.
261 case "$PACKAGE_TYPE" in
263 # All Arvados Python2 packages depend on Python 2.7.
264 # Make sure we build with that for consistency.
265 set -- "$@" --python-bin python2.7 \
266 --python-easyinstall "$EASY_INSTALL2" \
267 --python-package-name-prefix "$PYTHON2_PKG_PREFIX" \
268 --depends "$PYTHON2_PACKAGE"
271 # fpm does not actually support a python3 package type. Instead
272 # we recognize it as a convenience shortcut to add several
273 # necessary arguments to fpm's command line later, after we're
274 # done handling positional arguments.
276 set -- "$@" --python-bin python3 \
277 --python-easyinstall "$EASY_INSTALL3" \
278 --python-package-name-prefix "$PYTHON3_PKG_PREFIX" \
279 --depends "$PYTHON3_PACKAGE"
283 declare -a COMMAND_ARR=("fpm" "--maintainer=Ward Vandewege <ward@curoverse.com>" "-s" "$PACKAGE_TYPE" "-t" "$FORMAT")
284 if [ python = "$PACKAGE_TYPE" ]; then
285 COMMAND_ARR+=(--exclude=\*/{dist,site}-packages/tests/\*)
288 if [[ "$PACKAGE_NAME" != "$PACKAGE" ]]; then
289 COMMAND_ARR+=('-n' "$PACKAGE_NAME")
292 if [[ "$VENDOR" != "" ]]; then
293 COMMAND_ARR+=('--vendor' "$VENDOR")
296 if [[ "$VERSION" != "" ]]; then
297 COMMAND_ARR+=('-v' "$VERSION")
300 # Append remaining function arguments directly to fpm's command line.
305 COMMAND_ARR+=("$PACKAGE")
307 if [[ "$DEBUG" != 0 ]]; then
309 echo "${COMMAND_ARR[@]}"
313 FPM_RESULTS=$("${COMMAND_ARR[@]}")
316 fpm_verify_and_scp $FPM_EXIT_CODE $FPM_RESULTS
319 # verify build results and scp packages, if needed
320 fpm_verify_and_scp () {
326 if [[ $FPM_RESULTS =~ ([A-Za-z0-9_\.-]*\.)(deb|rpm) ]]; then
327 FPM_PACKAGE_NAME=${BASH_REMATCH[1]}${BASH_REMATCH[2]}
330 if [[ "$FPM_PACKAGE_NAME" == "" ]]; then
332 echo "Error: $PACKAGE: Unable to figure out package name from fpm results:"
337 if [[ ! $FPM_RESULTS =~ "File already exists" ]]; then
338 if [[ "$FPM_EXIT_CODE" != "0" ]]; then
339 echo "Error building package for $1:\n $FPM_RESULTS"
341 if [[ "$UPLOAD" != 0 ]]; then
342 scp -P2222 $FPM_PACKAGE_NAME $SCPUSER@$SCPHOST:$FPM_OUTDIR/
347 echo "Package $FPM_PACKAGE_NAME exists, not rebuilding"
352 if [[ -f /etc/profile.d/rvm.sh ]]; then
353 source /etc/profile.d/rvm.sh
356 # Make all files world-readable -- jenkins runs with umask 027, and has checked
357 # out our git tree here
358 chmod o+r "$WORKSPACE" -R
360 # More cleanup - make sure all executables that we'll package are 755
361 find -type d -name 'bin' |xargs -I {} find {} -type f |xargs -I {} chmod 755 {}
363 # Now fix our umask to something better suited to building and publishing
367 if [[ "$DEBUG" != 0 ]]; then
368 echo "umask is" `umask`
371 if [[ ! -d "$WORKSPACE/packages/$TARGET" ]]; then
372 mkdir -p $WORKSPACE/packages/$TARGET
376 if [[ "$DEBUG" != 0 ]]; then
377 echo -e "\nPerl packages\n"
380 if [[ "$DEBUG" != 0 ]]; then
386 cd "$WORKSPACE/sdk/perl"
388 if [[ -e Makefile ]]; then
389 make realclean >"$PERL_OUT"
391 find -maxdepth 1 \( -name 'MANIFEST*' -or -name "libarvados-perl*.$FORMAT" \) \
395 perl Makefile.PL INSTALL_BASE=install >"$PERL_OUT" && \
396 make install INSTALLDIRS=perl >"$PERL_OUT" && \
397 fpm_build_and_scp install/lib/=/usr/share libarvados-perl \
398 "Curoverse, Inc." dir "$(version_from_git)" install/man/=/usr/share/man && \
399 mv libarvados-perl*.$FORMAT "$WORKSPACE/packages/$TARGET/"
402 if [[ "$DEBUG" != 0 ]]; then
408 if type rvm-exec >/dev/null 2>&1; then
409 FPM_GEM_PREFIX=$(rvm-exec system gem environment gemdir)
411 FPM_GEM_PREFIX=$(gem environment gemdir)
417 ARVADOS_GEM_EPOCH=`git log -n1 --first-parent --format=%ct`
418 ARVADOS_GEM_DATE=`date --utc --date="@${ARVADOS_GEM_EPOCH}" +%Y%m%d%H%M%S`
419 ARVADOS_GEM_VERSION="0.1.${ARVADOS_GEM_DATE}"
421 # see if this gem needs building/uploading
422 gem search arvados -r -a |grep -q $ARVADOS_GEM_VERSION
424 if [[ "$?" != "0" ]]; then
425 # clean up old packages
426 find -maxdepth 1 \( -name 'arvados-*.gem' -or -name 'rubygem-arvados_*.deb' -or -name 'rubygem-arvados_*.rpm' \) \
429 if [[ "$DEBUG" != 0 ]]; then
430 gem build arvados.gemspec
432 # -q appears to be broken in gem version 2.2.2
433 gem build arvados.gemspec -q >/dev/null 2>&1
436 if [[ "$UPLOAD" != 0 ]]; then
438 gem push arvados-*gem
441 fpm_build_and_scp arvados-*.gem "" "Curoverse, Inc." gem "" \
442 --prefix "$FPM_GEM_PREFIX"
445 # Build arvados-cli GEM
449 ARVADOS_CLI_GEM_EPOCH=`git log -n1 --first-parent --format=%ct`
450 ARVADOS_CLI_GEM_DATE=`date --utc --date="@${ARVADOS_CLI_GEM_EPOCH}" +%Y%m%d%H%M%S`
451 ARVADOS_CLI_GEM_VERSION="0.1.${ARVADOS_CLI_GEM_DATE}"
453 # see if this gem needs building/uploading
454 gem search arvados-cli -r -a |grep -q $ARVADOS_GEM_VERSION
456 if [[ "$?" != "0" ]]; then
458 rm -f arvados-cli*gem
460 if [[ "$DEBUG" != 0 ]]; then
461 gem build arvados-cli.gemspec
463 # -q appears to be broken in gem version 2.2.2
464 gem build arvados-cli.gemspec -q >/dev/null
467 if [[ "$UPLOAD" != 0 ]]; then
469 gem push arvados-cli*gem
474 if [[ "$DEBUG" != 0 ]]; then
476 echo "Python packages"
483 handle_python_package
485 cd ../../services/fuse
486 handle_python_package
488 cd ../../services/nodemanager
489 handle_python_package
492 # We use $WORKSPACE/src-build-dir as the clean directory from which to build the src package
493 if [[ ! -d "$WORKSPACE/src-build-dir" ]]; then
494 mkdir "$WORKSPACE/src-build-dir"
496 if [[ "$DEBUG" != 0 ]]; then
497 git clone https://github.com/curoverse/arvados.git src-build-dir
499 git clone -q https://github.com/curoverse/arvados.git src-build-dir
503 cd "$WORKSPACE/src-build-dir"
504 # just in case, check out master
505 if [[ "$DEBUG" != 0 ]]; then
508 # go into detached-head state
509 git checkout `git log --format=format:%h -n1 --first-parent .`
511 git checkout -q master
513 # go into detached-head state
514 git checkout -q `git log --format=format:%h -n1 --first-parent .`
517 git log --format=format:%H -n1 --first-parent . > git-commit.version
519 # Build arvados src deb package
521 PKG_VERSION=$(version_from_git)
522 cd $WORKSPACE/packages/$TARGET
523 fpm_build_and_scp $WORKSPACE/src-build-dir/=/usr/local/arvados/src arvados-src 'Curoverse, Inc.' 'dir' "$PKG_VERSION" "--exclude=usr/local/arvados/src/.git" "--url=https://arvados.org" "--license=GNU Affero General Public License, version 3.0" "--description=The Arvados source code" "--architecture=all"
525 # clean up, check out master and step away from detached-head state
526 cd "$WORKSPACE/src-build-dir"
527 if [[ "$DEBUG" != 0 ]]; then
530 git checkout -q master
534 export GOPATH=$(mktemp -d)
535 mkdir -p "$GOPATH/src/git.curoverse.com"
536 ln -sfn "$WORKSPACE" "$GOPATH/src/git.curoverse.com/arvados.git"
539 cd "$GOPATH/src/git.curoverse.com/arvados.git/services/keepstore"
540 PKG_VERSION=$(version_from_git)
541 go get "git.curoverse.com/arvados.git/services/keepstore"
542 cd $WORKSPACE/packages/$TARGET
543 fpm_build_and_scp $GOPATH/bin/keepstore=/usr/bin/keepstore keepstore 'Curoverse, Inc.' 'dir' "$PKG_VERSION" "--url=https://arvados.org" "--license=GNU Affero General Public License, version 3.0" "--description=Keepstore is the Keep storage daemon, accessible to clients on the LAN"
546 cd "$GOPATH/src/git.curoverse.com/arvados.git/sdk/go"
547 GO_SDK_VERSION=$(version_from_git)
548 GO_SDK_TIMESTAMP=$(timestamp_from_git)
551 cd "$GOPATH/src/git.curoverse.com/arvados.git/services/keepproxy"
552 KEEPPROXY_VERSION=$(version_from_git)
553 KEEPPROXY_TIMESTAMP=$(timestamp_from_git)
555 if [[ "$GO_SDK_TIMESTAMP" -gt "$KEEPPROXY_TIMESTAMP" ]]; then
556 PKG_VERSION=$GO_SDK_VERSION
558 PKG_VERSION=$KEEPPROXY_VERSION
561 go get "git.curoverse.com/arvados.git/services/keepproxy"
562 cd $WORKSPACE/packages/$TARGET
563 fpm_build_and_scp $GOPATH/bin/keepproxy=/usr/bin/keepproxy keepproxy 'Curoverse, Inc.' 'dir' "$PKG_VERSION" "--url=https://arvados.org" "--license=GNU Affero General Public License, version 3.0" "--description=Keepproxy makes a Keep cluster accessible to clients that are not on the LAN"
566 cd "$GOPATH/src/git.curoverse.com/arvados.git/services/datamanager"
567 DATAMANAGER_VERSION=$(version_from_git)
568 DATAMANAGER_TIMESTAMP=$(timestamp_from_git)
570 if [[ "$GO_SDK_TIMESTAMP" -gt "$DATAMANAGER_TIMESTAMP" ]]; then
571 PKG_VERSION=$GO_SDK_VERSION
573 PKG_VERSION=$DATAMANAGER_VERSION
576 go get "git.curoverse.com/arvados.git/services/datamanager"
577 cd $WORKSPACE/packages/$TARGET
578 fpm_build_and_scp $GOPATH/bin/datamanager=/usr/bin/arvados-data-manager arvados-data-manager 'Curoverse, Inc.' 'dir' "$PKG_VERSION" "--url=https://arvados.org" "--license=GNU Affero General Public License, version 3.0" "--description=Datamanager ensures block replication levels, reports on disk usage and determines which blocks should be deleted when space is needed."
581 cd "$GOPATH/src/git.curoverse.com/arvados.git/services/arv-git-httpd"
582 ARVGITHTTPD_VERSION=$(version_from_git)
583 ARVGITHTTPD_TIMESTAMP=$(timestamp_from_git)
585 if [[ "$GO_SDK_TIMESTAMP" -gt "$ARVGITHTTPD_TIMESTAMP" ]]; then
586 PKG_VERSION=$GO_SDK_VERSION
588 PKG_VERSION=$ARVGITHTTPD_VERSION
591 go get "git.curoverse.com/arvados.git/services/arv-git-httpd"
592 cd $WORKSPACE/packages/$TARGET
593 fpm_build_and_scp $GOPATH/bin/arv-git-httpd=/usr/bin/arvados-git-httpd arvados-git-httpd 'Curoverse, Inc.' 'dir' "$PKG_VERSION" "--url=https://arvados.org" "--license=GNU Affero General Public License, version 3.0" "--description=Provides authenticated http access to Arvados-hosted git repositories."
596 cd "$GOPATH/src/git.curoverse.com/arvados.git/services/crunchstat"
597 PKG_VERSION=$(version_from_git)
598 go get "git.curoverse.com/arvados.git/services/crunchstat"
599 cd $WORKSPACE/packages/$TARGET
600 fpm_build_and_scp $GOPATH/bin/crunchstat=/usr/bin/crunchstat crunchstat 'Curoverse, Inc.' 'dir' "$PKG_VERSION" "--url=https://arvados.org" "--license=GNU Affero General Public License, version 3.0" "--description=Crunchstat gathers cpu/memory/network statistics of running Crunch jobs"
603 # Please resist the temptation to add --no-python-fix-name to the fpm call here
604 # (which would remove the python- prefix from the package name), because this
605 # package is a dependency of arvados-fuse, and fpm can not omit the python-
606 # prefix from only one of the dependencies of a package... Maybe I could
607 # whip up a patch and send it upstream, but that will be for another day. Ward,
609 cd $WORKSPACE/packages/$TARGET
610 fpm_build_and_scp $WORKSPACE/sdk/python "${PYTHON2_PKG_PREFIX}-arvados-python-client" 'Curoverse, Inc.' 'python' "$(awk '($1 == "Version:"){print $2}' $WORKSPACE/sdk/python/arvados_python_client.egg-info/PKG-INFO)" "--url=https://arvados.org" "--description=The Arvados Python SDK"
613 # Please see comment about --no-python-fix-name above; we stay consistent and do
614 # not omit the python- prefix first.
615 cd $WORKSPACE/packages/$TARGET
616 fpm_build_and_scp $WORKSPACE/services/fuse "${PYTHON2_PKG_PREFIX}-arvados-fuse" 'Curoverse, Inc.' 'python' "$(awk '($1 == "Version:"){print $2}' $WORKSPACE/services/fuse/arvados_fuse.egg-info/PKG-INFO)" "--url=https://arvados.org" "--description=The Keep FUSE driver"
619 cd $WORKSPACE/packages/$TARGET
620 fpm_build_and_scp $WORKSPACE/services/nodemanager arvados-node-manager 'Curoverse, Inc.' 'python' "$(awk '($1 == "Version:"){print $2}' $WORKSPACE/services/nodemanager/arvados_node_manager.egg-info/PKG-INFO)" "--url=https://arvados.org" "--description=The Arvados node manager"
622 # The Docker image cleaner
623 cd $WORKSPACE/packages/$TARGET
624 fpm_build_and_scp $WORKSPACE/services/dockercleaner arvados-docker-cleaner 'Curoverse, Inc.' 'python3' "$(awk '($1 == "Version:"){print $2}' $WORKSPACE/services/dockercleaner/arvados_docker_cleaner.egg-info/PKG-INFO)" "--url=https://arvados.org" "--description=The Arvados Docker image cleaner"
627 for deppkg in "${PYTHON_BACKPORTS[@]}"; do
628 outname=$(echo "$deppkg" | sed -e 's/^python-//' -e 's/[<=>].*//' -e 's/_/-/g' -e "s/^/${PYTHON2_PKG_PREFIX}-/")
629 fpm_build_and_scp "$deppkg" "$outname"
632 # Python 3 dependencies
633 for deppkg in "${PYTHON3_BACKPORTS[@]}"; do
634 outname=$(echo "$deppkg" | sed -e 's/^python-//' -e 's/[<=>].*//' -e 's/_/-/g' -e "s/^/${PYTHON3_PKG_PREFIX}-/")
635 # The empty string is the vendor argument: these aren't Curoverse software.
636 fpm_build_and_scp "$deppkg" "$outname" "" python3
639 # Build the API server package
641 cd "$WORKSPACE/services/api"
643 API_VERSION=$(version_from_git)
644 PACKAGE_NAME=arvados-api-server
646 if [[ ! -d "$WORKSPACE/services/api/tmp" ]]; then
647 mkdir $WORKSPACE/services/api/tmp
650 BUNDLE_OUTPUT=`bundle install --path vendor/bundle`
652 if [[ "$DEBUG" != 0 ]]; then
656 /usr/bin/git rev-parse HEAD > git-commit.version
658 cd $WORKSPACE/packages/$TARGET
660 # Annoyingly, we require a database.yml file for rake assets:precompile to work. So for now,
661 # we do that in the upgrade script.
662 # TODO: add bogus database.yml file so we can precompile the assets and put them in the
663 # package. Then remove that database.yml file again. It has to be a valid file though.
664 #RAILS_ENV=production RAILS_GROUPS=assets bundle exec rake assets:precompile
666 # This is the complete package with vendor/bundle included.
667 # It's big, so we do not build it by default.
668 if [[ "$BUILD_BUNDLE_PACKAGES" != 0 ]]; then
669 declare -a COMMAND_ARR=("fpm" "--maintainer=Ward Vandewege <ward@curoverse.com>" "--vendor='Curoverse, Inc.'" "--url='https://arvados.org'" "--description='Arvados API server - Arvados is a free and open source platform for big data science.'" "--license='GNU Affero General Public License, version 3.0'" "-s" "dir" "-t" "$FORMAT" "-n" "${PACKAGE_NAME}-with-bundle" "-v" "$API_VERSION" "-x" "var/www/arvados-api/current/tmp" "-x" "var/www/arvados-api/current/log" "-x" "var/www/arvados-api/current/vendor/cache/*" "-x" "var/www/arvados-api/current/coverage" "-x" "var/www/arvados-api/current/Capfile*" "-x" "var/www/arvados-api/current/config/deploy*" "--after-install=$RUN_BUILD_PACKAGES_PATH/arvados-api-server-extras/postinst.sh" "$WORKSPACE/services/api/=/var/www/arvados-api/current" "$RUN_BUILD_PACKAGES_PATH/arvados-api-server-extras/arvados-api-server-upgrade.sh=/usr/local/bin/arvados-api-server-upgrade.sh")
671 if [[ "$DEBUG" != 0 ]]; then
673 echo "${COMMAND_ARR[@]}"
677 FPM_RESULTS=$("${COMMAND_ARR[@]}")
679 fpm_verify_and_scp $FPM_EXIT_CODE $FPM_RESULTS
682 # Build the 'bare' package without vendor/bundle.
683 declare -a COMMAND_ARR=("fpm" "--maintainer=Ward Vandewege <ward@curoverse.com>" "--vendor='Curoverse, Inc.'" "--url='https://arvados.org'" "--description='Arvados API server - Arvados is a free and open source platform for big data science.'" "--license='GNU Affero General Public License, version 3.0'" "-s" "dir" "-t" "$FORMAT" "-n" "${PACKAGE_NAME}" "-v" "$API_VERSION" "-x" "var/www/arvados-api/current/tmp" "-x" "var/www/arvados-api/current/log" "-x" "var/www/arvados-api/current/vendor/bundle" "-x" "var/www/arvados-api/current/vendor/cache/*" "-x" "var/www/arvados-api/current/coverage" "-x" "var/www/arvados-api/current/Capfile*" "-x" "var/www/arvados-api/current/config/deploy*" "--after-install=$RUN_BUILD_PACKAGES_PATH/arvados-api-server-extras/postinst.sh" "$WORKSPACE/services/api/=/var/www/arvados-api/current" "$RUN_BUILD_PACKAGES_PATH/arvados-api-server-extras/arvados-api-server-upgrade.sh=/usr/local/bin/arvados-api-server-upgrade.sh")
685 if [[ "$DEBUG" != 0 ]]; then
687 echo "${COMMAND_ARR[@]}"
691 FPM_RESULTS=$("${COMMAND_ARR[@]}")
693 fpm_verify_and_scp $FPM_EXIT_CODE $FPM_RESULTS
695 # API server package build done
697 # Build the workbench server package
699 cd "$WORKSPACE/apps/workbench"
701 WORKBENCH_VERSION=$(version_from_git)
702 PACKAGE_NAME=arvados-workbench
704 if [[ ! -d "$WORKSPACE/apps/workbench/tmp" ]]; then
705 mkdir $WORKSPACE/apps/workbench/tmp
708 BUNDLE_OUTPUT=`bundle install --path vendor/bundle`
710 if [[ "$DEBUG" != 0 ]]; then
714 /usr/bin/git rev-parse HEAD > git-commit.version
716 # clear the tmp directory; the asset generation step will recreate tmp/cache/assets,
717 # and we want that in the package, so it's easier to not exclude the tmp directory
718 # from the package - empty it instead.
719 rm -rf $WORKSPACE/apps/workbench/tmp/*
721 # Set up application.yml so that asset precompilation works
722 \cp config/application.yml.example config/application.yml -f
723 sed -i 's/secret_token: ~/secret_token: xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx/' config/application.yml
725 RAILS_ENV=production RAILS_GROUPS=assets bundle exec rake assets:precompile >/dev/null
727 if [[ "$?" != "0" ]]; then
728 echo "ERROR: Asset precompilation failed"
732 cd $WORKSPACE/packages/$TARGET
734 # This is the complete package with vendor/bundle included.
735 # It's big, so we do not build it by default.
736 if [[ "$BUILD_BUNDLE_PACKAGES" != 0 ]]; then
738 declare -a COMMAND_ARR=("fpm" "--maintainer=Ward Vandewege <ward@curoverse.com>" "--vendor='Curoverse, Inc.'" "--url='https://arvados.org'" "--description='Arvados Workbench - Arvados is a free and open source platform for big data science.'" "--license='GNU Affero General Public License, version 3.0'" "-s" "dir" "-t" "$FORMAT" "-n" "${PACKAGE_NAME}-with-bundle" "-v" "$WORKBENCH_VERSION" "-x" "var/www/arvados-workbench/current/log" "-x" "var/www/arvados-workbench/current/vendor/cache/*" "-x" "var/www/arvados-workbench/current/coverage" "-x" "var/www/arvados-workbench/current/Capfile*" "-x" "var/www/arvados-workbench/current/config/deploy*" "--after-install=$RUN_BUILD_PACKAGES_PATH/arvados-workbench-extras/postinst.sh" "$WORKSPACE/apps/workbench/=/var/www/arvados-workbench/current" "$RUN_BUILD_PACKAGES_PATH/arvados-workbench-extras/arvados-workbench-upgrade.sh=/usr/local/bin/arvados-workbench-upgrade.sh")
740 if [[ "$DEBUG" != 0 ]]; then
742 echo "${COMMAND_ARR[@]}"
746 FPM_RESULTS=$("${COMMAND_ARR[@]}")
748 fpm_verify_and_scp $FPM_EXIT_CODE $FPM_RESULTS
751 # Build the 'bare' package without vendor/bundle.
753 declare -a COMMAND_ARR=("fpm" "--maintainer=Ward Vandewege <ward@curoverse.com>" "--vendor='Curoverse, Inc.'" "--url='https://arvados.org'" "--description='Arvados Workbench - Arvados is a free and open source platform for big data science.'" "--license='GNU Affero General Public License, version 3.0'" "-s" "dir" "-t" "$FORMAT" "-n" "${PACKAGE_NAME}" "-v" "$WORKBENCH_VERSION" "-x" "var/www/arvados-workbench/current/log" "-x" "var/www/arvados-workbench/current/vendor/bundle" "-x" "var/www/arvados-workbench/current/vendor/cache/*" "-x" "var/www/arvados-workbench/current/coverage" "-x" "var/www/arvados-workbench/current/Capfile*" "-x" "var/www/arvados-workbench/current/config/deploy*" "--after-install=$RUN_BUILD_PACKAGES_PATH/arvados-workbench-extras/postinst.sh" "$WORKSPACE/apps/workbench/=/var/www/arvados-workbench/current" "$RUN_BUILD_PACKAGES_PATH/arvados-workbench-extras/arvados-workbench-upgrade.sh=/usr/local/bin/arvados-workbench-upgrade.sh")
755 if [[ "$DEBUG" != 0 ]]; then
757 echo "${COMMAND_ARR[@]}"
761 FPM_RESULTS=$("${COMMAND_ARR[@]}")
763 fpm_verify_and_scp $FPM_EXIT_CODE $FPM_RESULTS
765 # Workbench package build done
767 # Finally, publish the packages, if necessary
768 if [[ "$UPLOAD" != 0 && "$CALL_FREIGHT" != 0 ]]; then
769 ssh -p2222 $SCPUSER@$SCPHOST -t bash - <<EOF
770 if [ -n "\$(find $FPM_OUTDIR -name "*.$FORMAT" -print -quit)" ]; then
771 cd "$FPM_OUTDIR" && $REPO_UPDATE_CMD
775 if [[ "$UPLOAD" != 0 ]]; then
776 echo "No new packages generated. No freight run necessary."
780 # clean up temporary GOPATH